using System;
using System.Windows.Forms;

namespace TestSharpDx
{
	public static class Global
	{
		public static void Swap<T>(ref T a, ref T b)
		{
			T temp = a;
			a = b;
			b = temp;
		}

		public static T Clamp<T>(T _val, T _valMin, T _valMax) where T : IComparable
		{
			if (_valMin.CompareTo(_valMax) > 0)
				Swap(ref _valMin, ref _valMax);

			if (_val.CompareTo(_valMin) <= 0)
				return (T)_valMin;
			else if (_val.CompareTo(_valMax) >= 0)
				return (T)_valMax;
			else
				return (T)_val;
		}
	}

	public class ListViewEx : ListView
	{
		/// <summary>
		/// Normally the selected line is grayed when the control has no focus.
		/// By overriding the DefWndProc we suppress this behavior and the line stays blue
		/// </summary>
		/// <param name="msg"></param>
		protected override void DefWndProc(ref Message msg)
		{
			if (msg.Msg != 8)
				base.DefWndProc(ref msg);
		}
	}

}

